CREATE SCHEMA Allgemeine_Objekte

-- Historie:
--
-- 15.10.1999 - 1.000 (1.000)
-- Erste Version des OKSTRA verabschiedet

CREATE TABLE Wochentag (
   Kennung
      INTEGER NOT NULL PRIMARY KEY,
   Langtext
      VARCHAR(10) NOT NULL
)

INSERT INTO Wochentag VALUES (1,'Sonntag')
INSERT INTO Wochentag VALUES (2,'Montag')
INSERT INTO Wochentag VALUES (3,'Dienstag')
INSERT INTO Wochentag VALUES (4,'Mittwoch')
INSERT INTO Wochentag VALUES (5,'Donnerstag')
INSERT INTO Wochentag VALUES (6,'Freitag')
INSERT INTO Wochentag VALUES (7,'Samstag')

CREATE TABLE Startdatum (
   Startdatum_ID
      INTEGER NOT NULL PRIMARY KEY,
   Jahr
      INTEGER,
   Monat_im_Jahr
      INTEGER,
   Woche_im_Jahr
      INTEGER,
   Tag_im_Monat
      INTEGER,
   vorwaerts_oder_rueckwaerts
      INTEGER REFERENCES Logical_Types.Boolean,
   Woche_im_Monat
      INTEGER,
   Tag_in_der_Woche
      INTEGER,
   Stunde_am_Tag
      INTEGER,
   Minute_in_der_Stunde
      INTEGER,
   Sekunde_in_der_Minute
      INTEGER,
   CHECK ( ( Monat_im_Jahr IS NULL ) OR ( Woche_im_Jahr IS NULL ) )
)

CREATE TABLE Dauer (
   Dauer_ID
      INTEGER NOT NULL PRIMARY KEY,
   Jahre
      INTEGER,
   Monate
      INTEGER,
   Wochen
      INTEGER,
   Tage
      INTEGER,
   Stunden
      INTEGER,
   Minuten
      INTEGER,
   Sekunden
      INTEGER
)

CREATE TABLE Operator (
   Kennung
      CHAR(1) NOT NULL PRIMARY KEY,
   Langtext
      VARCHAR(255) NOT NULL
)

INSERT INTO Operator VALUES ('+','Vereinigung')
INSERT INTO Operator VALUES ('*','Durchschnitt')
INSERT INTO Operator VALUES ('-','Differenz')

CREATE TABLE Zeitraum (
   Zeitraum_ID
      INTEGER NOT NULL PRIMARY KEY,
   hat_ersten_Zeitraum
      INTEGER REFERENCES Zeitraum,
   hat_zweiten_Zeitraum
      INTEGER REFERENCES Zeitraum,
   hat_Operator
      CHAR(1) REFERENCES Operator,
   hat_Startdatum
      INTEGER REFERENCES Startdatum,
   hat_Dauer
      INTEGER REFERENCES Dauer,
   FOREIGN KEY (Zeitraum_ID) REFERENCES Historisierung.historisches_Objekt,
   gueltig_von
      CHAR(10) NOT NULL, -- Datum
   CHECK ( gueltig_von LIKE '__.__.____' ),
   gueltig_bis
      CHAR(10) NOT NULL, -- Datum
   CHECK ( gueltig_bis LIKE '__.__.____' ),
   Art_Zeitraum
      INTEGER NOT NULL REFERENCES Art_Zeitraum
)

CREATE TABLE Art_Zeitraum (
   Kennung
      INTEGER NOT NULL PRIMARY KEY,
   Langtext
      VARCHAR(18) NOT NULL
)

INSERT INTO Art_Zeitraum VALUES (1,'einfacher_Zeitraum')
INSERT INTO Art_Zeitraum VALUES (2,'komplexer_Zeitraum')

CREATE TABLE verwaltungstechn_Zuordnung (
   verwaltungstechn_Zuordnung_ID
      INTEGER NOT NULL PRIMARY KEY,
   hat_Strassenbaudienststelle
      INTEGER NOT NULL REFERENCES Administration.Strassenbaudienststelle,
   hat_Verwaltungsbezirk
      INTEGER NOT NULL REFERENCES Administration.Verwaltungsbezirk
)

CREATE TABLE oertliche_Zuordnung (
   oertliche_Zuordnung_ID
      INTEGER NOT NULL PRIMARY KEY,
   liegt_auf_Strassenpunkt
      INTEGER REFERENCES oertliche_Zuordnung_SP,
   liegt_auf_nicht_klass_Strasse
      INTEGER REFERENCES nicht_nach_ASB_klass_Strasse,
   CHECK ( ( ( liegt_auf_Strassenpunkt IS NOT NULL ) OR ( liegt_auf_nicht_klass_Strasse IS NOT NULL ) ) AND ( ( liegt_auf_Strassenpunkt IS NULL ) OR ( liegt_auf_nicht_klass_Strasse IS NULL ) ) )
)

CREATE TABLE oertliche_Zuordnung_SP (
   oertliche_Zuordnung_SP_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (oertliche_Zuordnung_SP_ID) REFERENCES Strassennetz.Punktobjekt_stat
)

CREATE TABLE nicht_nach_ASB_klass_Strasse (
   nicht_nach_ASB_klass_Strasse_ID
      INTEGER NOT NULL PRIMARY KEY,
   Strassenklasse
      VARCHAR(50) NOT NULL,
   Nummer
      INTEGER NOT NULL,
   Lage
      VARCHAR(28) NOT NULL
)



CREATE SCHEMA Logical_Types


CREATE TABLE Boolean (
   Boolean_ID
      INTEGER NOT NULL PRIMARY KEY,
   Boolean
      VARCHAR (5)
) 

INSERT INTO Boolean VALUES ( 0 , 'FALSE' ) 
INSERT INTO Boolean VALUES ( 1 , 'TRUE' ) 


